import { Component, OnDestroy, OnChanges, OnInit, ApplicationRef, ChangeDetectorRef, ViewChild, ElementRef } from '@angular/core';
import { ComponentBase } from './ComponentBase';
import { MetaFormCreator } from './mataFormCreator';

@Component({
  selector: 'app-form',
  templateUrl: './form.component.html',
  styleUrls: ['./form.component.css']
})
export class FormComponent extends ComponentBase implements OnInit, OnChanges, OnDestroy {
  // 储存数据用
  saveKey = "hy_06";

  item = {
    onlineFlg: false,
    title: "钓鱼大作战",
    questionText: "海洋里有很多鱼，每条鱼身上都藏着魔法信息！亲爱的小玩家，请仔细听游戏指令，找到含有正确魔法信息的鱼，快速完成钓鱼。 在本次的游戏中，你将和其他玩家进行PK，游戏结束，钓鱼数量最多的玩家，将获得胜利。最后根据钓鱼的数量，你将获得相应的能量石奖励！开始挑战吧！",
    questionTextAudio: "http://staging-teach.cdn.ireadabc.com/e422c682ff3304a532937db64573caa4.mp3",
    questions: [],
    bgAudio: "",
    bgAudioName: "",
    audioName: ""
  };
  isVisible = false;
  deleteTitle = "是否删除题目";
  deleteCallback = function () { };
  openDelete(title, callback) {
    this.deleteCallback = callback;
    this.deleteTitle = title;
    this.isVisible = true;
  }
  handleCancel() {
    this.isVisible = false;
  }
  handleOk() {
    this.deleteCallback && this.deleteCallback();
    this.handleCancel();
  }


  init(): void {
    /* console.log(new MetaFormCreator().create()); */
  }

  removeoption(i, j) {
    if ((this.item.questions[i].optionsType == "img" || this.item.questions[i].optionsType == "shortTxt") && this.item.questions[i].letterList.length > 2) {
      this.openDelete("确定减少选项？", () => {
        this.item.questions[i].letterList.splice(j, 2);
        this.save();
      })
    } else {
      this.openDelete("确定减少选项？", () => {
        this.item.questions[i].letterList.splice(j, 1);
        this.save();
      })
    }

  }
  copyOption(i, j) {
    let data = this.item.questions[i].letterList[j];
    this.item.questions[i].letterList.push(JSON.parse(JSON.stringify(data)));
    this.save();
  }
  addoption(i) {
    this.item.questions[i].letterList.push({
      answer: '',
      image: "",
      shortText: "",
      longText: "",
    })
    this.save();
  }

  removequestion(i) {
    this.openDelete("确定删除题目？", () => {
      this.item.questions.splice(i, 1);
      this.save();
    })
  }

  addquestion() {
    this.item.questions.push({
      optionsType: "img",
      questionAudio: "",
      duration: 120,
      type: "img",
      image: "",
      index: '',
      audio: "",
      text: "",
      right: false,
      letterList: [],
    });
    this.save();
  }
  deleteBgAudio() {
    this.item.bgAudio = "";
    this.item.bgAudioName = "";
    this.save();
  }
  button1() {
    console.log(this.item, '456')
  }
  ngChange(i) {
    for (let a = 0; a < this.item.questions[i].letterList.length; a++) {
      this.item.questions[i].letterList[a].answer = false
    }
    this.item.questions[i].letterList[this.item.questions[i].index].answer = true
    this.save();
  }
}